// 使用するポートを設定します。
P_DIN = 1
P_LOAD = 2
P_CLK = 3

// テストプログラム
init()
for i = 1 to 8
	max7219(i, i) // 87654321を表示
next
pause 1000
for i = 1 to 8
	max7219(i, 9 - i) // 123456778を表示
next
end

// 初期化します。
def init() {
	out P_LOAD, 1
	out P_DIN, 0
	out P_CLK, 0
	pause 1
	setDisplayTest(0)
	setDecode(0xff)
	setIntensity(15)
	setScanLimit(7)
	shutdown(0)
}

// テストモード(0:ノーマル、1:テスト)を設定します。
def setDisplayTest(mode) {
	max7219(15, mode)
}

// デコードモード(0xff:デコード、0:ビット指定)を設定します。
def setDecode(mode) {
	max7219(9, mode)
}

// 輝度(0～15)を設定します。
def setIntensity(intensity) {
	max7219(10, intensity)
}

// 表示桁数(0～7で1桁～8桁)を設定します。
def setScanLimit(limit) {
	max7219(11, limit)
}

// 表示をON/OFFします。
def shutdown(sw) {
	max7219(12, !sw)
}

// コマンドを発行します。
def max7219(addr, data) {
	out P_LOAD, 0
	sftout P_DIN, P_CLK, 0, addr
	sftout P_DIN, P_CLK, 0, data
	out P_LOAD, 1
	pause 1
}
